package bookExamples.ch44Printing;

import javax.print.PrintService;
import java.awt.*;
import java.awt.print.*;

public class PrintTest implements Printable {
    public int print(Graphics graphics, PageFormat pageFormat, int pageIndex)
            throws PrinterException {
        if (pageIndex == 0) {
            System.out.println("imageable X      = " + pageFormat.getImageableX());
            System.out.println("imageable Y      = " + pageFormat.getImageableY());
            System.out.println("imageable Width  = " + pageFormat.getImageableWidth());
            System.out.println("imageable Height = " + pageFormat.getImageableHeight());
            Graphics2D g = (Graphics2D) graphics;
            // g.translate(pageFormat.getImageableX(), pageFormat.getImageableY());
            //g.drawString("1111", -50.0f, -50.0f);
            //g.drawString("2222", -50.0f,  50.0f);
            //g.drawString("3333",  50.0f, -50.0f);
            for (int i=0; i < 10; i++)
               g.drawString("4444", 72.0f, i*72.0f);


            return PAGE_EXISTS;
        } else
            return NO_SUCH_PAGE;
    }

    public static void main(String[] args) {
        PrinterJob printerJob = PrinterJob.getPrinterJob();
        PrintService[] printService = PrinterJob.lookupPrintServices();
        for (int i = 0; i < printService.length; i++) {
            System.out.println(printService[i].getName());
        }
        PageFormat pageFormat = printerJob.defaultPage();
        Paper paper = new Paper();
        double width = 8.5 * 72;
        double height = 11 * 72;
        paper.setSize(width, height);
        // Large Address Dimension
        double margin = 1*72;
        paper.setImageableArea(margin, margin, width-margin, height-margin);

        pageFormat.setPaper(paper);

        pageFormat.setOrientation(PageFormat.PORTRAIT);

        if (printerJob.printDialog()) {
            printerJob.setPrintable(new PrintTest(), pageFormat);
            // The 2nd param is necessary for printing into
            // a label width a right landscape format.
            try {
                printerJob.print();
            } catch (PrinterException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }
}

 
