package net.rmi.rjs.pk.rmiFileTransfer;

import futils.Futil;
import net.rmi.rjs.pk.LusCs.LusRcvr;
import net.rmi.rjs.pk.LusCs.RemoteJob;

import java.io.File;
import java.io.IOException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

/**
 * Created by IntelliJ IDEA. User: pkrepszt Date: Mar 13, 2005 Time:
 * 7:28:49 PM To change this template use File | Settings | File
 * Templates.
 */
public class FileTransClient {

    /**
     * Use the RMIUrl to lookup a FileTransClient. For example:
     * <p>
     * <code>
     * FileTransInterface fti = FileTransClient.lookupServer(rmiUrl);
     * </code>
     * @param rmiUrl   rmi://ipaddress/RmiImplementationName
     * @return
     * @throws NotBoundException
     * @throws java.net.MalformedURLException
     * @throws RemoteException
     */
    public static FileTransInterface lookupServer(String rmiUrl)
            throws NotBoundException,
                   java.net.MalformedURLException,
                   RemoteException {
        System.out.println("Naming.lookup(rmiUrl) " + rmiUrl);

        return (FileTransInterface)Naming.lookup(rmiUrl);
    }

    public void putJobJar(String rmiUrl, File f, String wsAnwserURL) {
        System.out.println("Location to send file " + rmiUrl);
        try {
            FileTransInterface fti = lookupServer(rmiUrl);
            byte b[] = Futil.readBytes(f);
            System.out.println("got b.length=" + b.length);
            RemoteJob rj = new RemoteJob();
            rj.setJarFileName(f.getName());
            rj.setJarContents(b);
            rj.setReturnAddress(LusRcvr.getLusIp());
            fti.putJob(rj, wsAnwserURL);

        } catch (NotBoundException e) {
            e.printStackTrace();
        } catch (java.net.MalformedURLException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();

        }
    }
    // put web start job URL to CS
    /**
     *
     * @param rmiUrl
     * @param jobURL
     * @param webServerIP
     */
    public int putJobURL(String rmiUrl, String jobURL ,String webServerIP) {
        System.out.println("Location to send file " + rmiUrl);
        try {
            String lusIpAddress = LusRcvr.getLusIp();
            FileTransInterface fti = lookupServer(rmiUrl);
            fti.putURL(jobURL, webServerIP,lusIpAddress);
        } catch (Exception e) {
             System.out.println("Problem with CS need to be removed from list");
            // e.printStackTrace();
             return 1;  // remove the CS from the list
            //e.printStackTrace();
        }
        return 0; 
    }

    public void getJarAnwser(String rmiUrl, File jar, String webServerIp) {
        System.out.println("getJarAnwser f.length =" + jar.length());
        System.out.println("Location to send file " + rmiUrl);
        try {
            //System.out.println("getJarAnwser f.length =" + jar.length());
            FileTransInterface fti = lookupServer(rmiUrl);
            System.out.println("beck to LUS Naming.lookup(rmiUrl) " + rmiUrl);
            //System.out.println("getJarAnwser f.length =" + jar.length());

            byte[] b = Futil.readBytes(jar);
            System.out.println("Lus got b.length=" + b.length);
            fti.putFile(jar.getName(), b);
            //fti.putFile("anwser.jar", b);
            fti.runLusAnwserFactory(jar.getName(), b, webServerIp);
        } catch (NotBoundException e) {
            e.printStackTrace();
        } catch (java.net.MalformedURLException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }
}

